<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.op.mes.mapper.ProRecipeMapper">

    <resultMap type="ProRecipe" id="ProRecipeResult">
        <result property="recipeId"    column="recipe_id"    />
        <result property="recipeCode"    column="recipe_code"    />
        <result property="recipeName"    column="recipe_name"    />
        <result property="attention"    column="attention"    />
        <result property="enableFlag"    column="enable_flag"    />
        <result property="remark"    column="remark"    />
        <result property="attr1"    column="attr1"    />
        <result property="attr2"    column="attr2"    />
        <result property="attr3"    column="attr3"    />
        <result property="attr4"    column="attr4"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="splitMerge"    column="split_merge"    />
        <result property="splitMergNum"    column="split_merg_num"    />
        <result property="sync"    column="sync"/>
        <result property="version"    column="version"/>
        <result property="workTime"    column="work_time"/>
    </resultMap>

    <sql id="selectProRecipeVo">
        select recipe_id, recipe_code, recipe_name, attention,
               enable_flag, remark, attr1, attr2, attr3, attr4, create_by, create_time,
               update_by, update_time,split_merge,split_merg_num,sync,version,work_time
        from pro_recipe
    </sql>

    <select id="selectProRecipeList" parameterType="ProRecipe" resultMap="ProRecipeResult">
        <include refid="selectProRecipeVo"/>
        <where>
            <if test="recipeCode != null  and recipeCode != ''"> and recipe_code = #{recipeCode}</if>
            <if test="recipeName != null  and recipeName != ''"> and recipe_name like concat('%', #{recipeName}, '%')</if>
            <if test="attention != null  and attention != ''"> and attention = #{attention}</if>
            <if test="enableFlag != null  and enableFlag != ''"> and enable_flag = #{enableFlag}</if>
        </where>
        order by create_time desc
    </select>

    <select id="selectProRecipeByRecipeId" parameterType="String" resultMap="ProRecipeResult">
        <include refid="selectProRecipeVo"/>
        where recipe_id = #{recipeId}
    </select>

	<select id="checkRecipeCodeUnique" parameterType="ProRecipe" resultMap="ProRecipeResult">
        select top 1 recipe_id, recipe_code, recipe_name, attention, enable_flag,
               remark, attr1, attr2, attr3, attr4, create_by, create_time,
                   update_by, update_time from pro_recipe
        where recipe_code = #{recipeCode}
    </select>

    <select id="checkRecipeNameUnique" parameterType="ProRecipe" resultMap="ProRecipeResult">
        select top 1 recipe_id, recipe_code, recipe_name, attention, enable_flag,
               remark, attr1, attr2, attr3, attr4, create_by, create_time,
                   update_by, update_time from pro_recipe
        where recipe_name = #{recipeName}
    </select>

    <insert id="insertProRecipe" parameterType="ProRecipe" useGeneratedKeys="true" keyProperty="recipeId">
        insert into pro_recipe
        <trim prefix="(" suffix=")" suffixOverrides=",">
            recipe_id,
            <if test="recipeCode != null and recipeCode != ''">recipe_code,</if>
            <if test="recipeName != null and recipeName != ''">recipe_name,</if>
            <if test="attention != null">attention,</if>
            <if test="enableFlag != null and enableFlag != ''">enable_flag,</if>
            <if test="remark != null">remark,</if>
            <if test="attr1 != null">attr1,</if>
            <if test="attr2 != null">attr2,</if>
            <if test="attr3 != null">attr3,</if>
            <if test="attr4 != null">attr4,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="splitMerge != null">split_merge,</if>
            <if test="splitMergNum != null">split_merg_num,</if>
            <if test="sync != null">sync,</if>
            <if test="version != null">version,</if>
            <if test="workTime != null">work_time,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            #{recipeId},
            <if test="recipeCode != null and recipeCode != ''">#{recipeCode},</if>
            <if test="recipeName != null and recipeName != ''">#{recipeName},</if>
            <if test="attention != null">#{attention},</if>
            <if test="enableFlag != null and enableFlag != ''">#{enableFlag},</if>
            <if test="remark != null">#{remark},</if>
            <if test="attr1 != null">#{attr1},</if>
            <if test="attr2 != null">#{attr2},</if>
            <if test="attr3 != null">#{attr3},</if>
            <if test="attr4 != null">#{attr4},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="splitMerge != null">#{splitMerge},</if>
            <if test="splitMergNum != null">#{splitMergNum},</if>
            <if test="sync != null">#{sync},</if>
            <if test="version != null">#{version},</if>
            <if test="workTime != null">#{workTime},</if>
         </trim>
    </insert>
    <update id="updateProRecipe" parameterType="ProRecipe">
        update pro_recipe
        <trim prefix="SET" suffixOverrides=",">
            <if test="recipeCode != null and recipeCode != ''">recipe_code = #{recipeCode},</if>
            <if test="recipeName != null and recipeName != ''">recipe_name = #{recipeName},</if>
            <if test="attention != null">attention = #{attention},</if>
            <if test="enableFlag != null and enableFlag != ''">enable_flag = #{enableFlag},</if>
            <if test="remark != null">remark = #{remark},</if>
            <if test="attr1 != null">attr1 = #{attr1},</if>
            <if test="attr2 != null">attr2 = #{attr2},</if>
            <if test="attr3 != null">attr3 = #{attr3},</if>
            <if test="attr4 != null">attr4 = #{attr4},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="splitMerge != null">split_merge = #{splitMerge},</if>
            <if test="splitMergNum != null">split_merg_num = #{splitMergNum},</if>
            <if test="sync != null">sync = #{sync},</if>
            <if test="version != null">version = #{version},</if>
            <if test="workTime != null">work_time = #{workTime},</if>
        </trim>
        where recipe_id = #{recipeId}
    </update>

    <delete id="deleteProRecipeByRecipeId" parameterType="String">
        delete from pro_recipe where recipe_id = #{recipeId}
    </delete>

    <delete id="deleteProRecipeByRecipeIds" parameterType="String">
        delete from pro_recipe where recipe_id in
        <foreach item="recipeId" collection="array" open="(" separator="," close=")">
            #{recipeId}
        </foreach>
    </delete>
</mapper>
